#include<iostream>
#include<iomanip>
#include<time.h>
#include<math.h>
using namespace std;

void changeTurn(char& turn);
void displayGameBoard(int xMoves, int oMoves);
int userMove(char turn, int allMoves);
void applyMove(char turn, int move, int& xMoves, int& oMoves);
bool playerWins(int moves);

void main()
{
	int xMoves = 0;
	int oMoves = 0;
	char turn = 'X';
	bool gameOver = false;

	while (!gameOver)
	{
		displayGameBoard(xMoves, oMoves);
		int move = userMove(turn, (xMoves | oMoves));
		applyMove(turn, move, xMoves, oMoves);

		if (playerWins(xMoves) || playerWins(oMoves))
		{
			gameOver = true;
		}
		//check for player win
		//check for CAT

		changeTurn(turn);
	}
	displayGameBoard(xMoves, oMoves);
}

void changeTurn(char& turn)
{
	if (turn == 'X')
	{
		turn = 'O';
	}
	else
	{
		turn = 'X';
	}
}

void displayPosition(int xMoves, int oMoves, int position)
{
	if ((xMoves & (int)pow(2, position)) == (int)pow(2, position))
	{
		cout << 'X';
	}
	else if ((oMoves & (int)pow(2, position)) == (int)pow(2, position))
	{
		cout << 'O';
	}
	else
	{
		cout << position;
	}
}

void displayGameBoard(int xMoves, int oMoves)
{
	system("cls");
	displayPosition(xMoves, oMoves, 1);
	cout << "|";
	displayPosition(xMoves, oMoves, 2);
	cout << "|";
	displayPosition(xMoves, oMoves, 3);
	cout << endl << "-----" << endl;
	displayPosition(xMoves, oMoves, 4);
	cout << "|";
	displayPosition(xMoves, oMoves, 5);
	cout << "|";
	displayPosition(xMoves, oMoves, 6);
	cout << endl << "-----" << endl;
	displayPosition(xMoves, oMoves, 7);
	cout << "|";
	displayPosition(xMoves, oMoves, 8);
	cout << "|";
	displayPosition(xMoves, oMoves, 9);
	cout << endl << endl;
}

int userMove(char turn, int allMoves)
{
	int result = 0;

	do
	{
		cout << turn << "'s turn: ";
		cin >> result;
	} while (result < 1 || result > 9 ||
		// if someone has already moved there
		((int)pow(2, result) & allMoves) == (int)pow(2, result) 
		);

	return result;
}

void applyMove(char turn, int move, int& xMoves, int& oMoves)
{
	if (turn == 'X')
	{
		xMoves = (xMoves | (int)(pow(2, move)));
	}
	else
	{
		oMoves = (oMoves | (int)(pow(2, move)));
	}
}

bool playerWins(int moves)
{
	bool result = false;

	if ((moves & 14) == 14 ||
		(moves & 112) == 112 ||
		(moves & 896) == 896 ||
		(moves & 146) == 146 ||
		(moves & 292) == 292 ||
		(moves & 584) == 584 ||
		(moves & 168) == 168 ||
		(moves & 546) == 546)
	{
		result = true;
	}

	return result;
}